# Get the simulation parameters (-param1 value1 -param2 value2...)
for {set i 0} {$i < $argc} {incr i} {
    global opt
    set arg [lindex $argv $i]
    if {[string range $arg 0 0] != "-"} continue
    set name [string range $arg 1 end]
    set opt($name) [lindex $argv [expr $i+1]]
}

global defaultRNG
$defaultRNG seed $opt(seed)

# Create a simulator object
set ns_ [new Simulator]

# Schedule events
for { set i 0} {$i < $opt(nn)} {incr i} {
    for { set j 0} {$j < 18} {incr j} {
	set dest [expr [ns-random] % $opt(nn)]
	if { $dest == $i } { 
	    if { $dest > 0 } {
		set dest [expr $dest -1]
	    } else {
		set dest [expr $dest + 1]
	    }
	}
	set send_time  [expr 10.0 + $j*200.0 + double([ns-random] % 19999)/100.0]
	set conn_id [expr 1000000*($i+1) + 1000*($dest+1) + ($j+1)]
	puts "set tcp_($conn_id) \[new Agent/TCP/Newreno]"
	puts "\$tcp_($conn_id) set fid_ $conn_id"
	puts "\$ns_ attach-agent \$node_($i) \$tcp_($conn_id)"
	puts "set sink_($conn_id) \[new Agent/TCPSink]"
	puts "\$ns_ attach-agent \$node_($dest) \$sink_($conn_id)"
	puts "\$ns_ connect \$tcp_($conn_id) \$sink_($conn_id)"
	puts "set ftp_($conn_id) \[new Application/FTP]"
	puts "\$ftp_($conn_id) attach-agent \$tcp_($conn_id)"
	#set file_size  [expr [ns-random] % 20001]
	puts "\$ns_ at $send_time \"\$ftp_($conn_id) send $opt(filesize)\""
    }
}

# Run the simulation
$ns_ run